
//#include "metalShaderTypes.h"

typedef struct
{
	float4 burnColor;
} fxVars;

typedef struct
{
    float4 position [[position]];
    float2 tex1;
    float2 tex2;
    float2 texMask;
    float2 normPos;
    float mixValue;
} vertexOut2;

vertex vertexOut2 vertexFunc(uint vertexID [[ vertex_id ]],const device txShaderVers* in[[ buffer(0) ]],constant txShaderUniforms& u[[ buffer(3) ]],constant fxVars& vars[[ buffer(2)]])
{
    vertexOut2 out;

    out.position=in[vertexID].pos*u.worldViewProj;

    out.tex1=in[vertexID].tex1;
	out.tex2=in[vertexID].tex2;
	out.texMask=in[vertexID].texMask;
	
	if(u.transitionState!=2)
	{
		if(u.transitionProgressLinear<=.5)
		{
			out.mixValue=0.;
		}
		else
		{
			out.mixValue=(u.transitionProgressLinear-.5f)*2.;
		}
	}
	else
	{
		if(u.transitionProgressLinear<=.5)
		{
			out.mixValue=(.5-u.transitionProgressLinear)*2.;
		}
		else
		{
			out.mixValue=0.;
		}
	}
	
    return out;
}

fragment float4 fragmentFunc(vertexOut2 in [[stage_in]]
							 ,texture2d<half> inputTex0 [[ texture(0) ]]
							 ,texture2d<half> inputTex1 [[ texture(1) ]]
							 ,texture2d<half> inputTexMask [[ texture(2) ]]
							 ,constant txShaderUniforms& u[[ buffer(2) ]]
							 ,constant fxVars& vars[[ buffer(1)]])
{
	
	float4 outColor = tex(inputTex0,in.tex1)*in.mixValue;

#ifdef USE_MASK
	outColor.a*=float(inputTexMask.sample(linearSampler,in.texMask).a);
#endif

	return outColor;
}
