#version 330

uniform sampler2DRect inputTex;
uniform sampler2DRect inputTex1;
uniform sampler2DRect maskTex;
uniform float transitionProgressLinear=1.0;
uniform float transitionAlpha=1.0;
uniform float baseAlpha=1.0;
uniform vec4 burnColor=vec4(0,0,0,1);

in vec2 fsTexture;
in vec2 fsTexture2;
in vec2 fsMaskTexture;
in float fsMix;

out vec4 outColor;

void main()
{
	vec4 texColor = texture(inputTex, fsTexture);
	vec4 colorA=mix(vec4(0,0,0,0),texColor,fsMix);
	vec4 colorB=mix(texColor,vec4(0,0,0,0),fsMix);
	vec4 useColor=vec4(burnColor.rgb,texColor.a);

    if(transitionProgressLinear<=.5)
    {
        outColor=mix(colorB,useColor,transitionProgressLinear*2.);
    }
    else
    {
        outColor=mix(useColor,colorA,(transitionProgressLinear-.5f)*2.);
    }
    outColor*=texColor.a;
#ifdef USE_MASK
    outColor.a*=texture(maskTex,fsMaskTexture).a;
#endif
}
