#if __METAL_MACOS__ || __METAL_IOS__
#include <metal_stdlib>
using namespace metal;
#endif

#include <simd/simd.h>


typedef struct
{
    vector_float4 pos;
	packed_float2 tex1;
	packed_float2 tex2;
	packed_float2 texMask;
} txShaderVers;

typedef struct
{
    vector_float4 pos;
	packed_float2 tex1;
	packed_float2 texMask;
} fxShaderVerts;

typedef struct
{
	int transitionState;
	float transitionProgressLinear;
	float transitionProgress;
	float lastTransitionProgress;
	float transitionAlpha;
	float timer;
	float baseAlpha;
	float mix;
	packed_float2 windowSize;
	packed_float2 uvScale;
	matrix_float4x4 worldViewProj;
} txShaderUniforms;

typedef struct
{
	int pass;
	float globalTime;
	float localTime;
	float random;
	float randomOnce;
	float blendValue;
} fxGeneralUniforms;

#if __METAL_MACOS__ || __METAL_IOS__
typedef struct
{
	float4 position [[position]];
	float2 tex1;
	float2 tex2;
	float2 texMask;
	float2 normPos;
} vertexOut;

typedef struct
{
	float4 position [[position]];
	float2 tex1;
	float2 texMask;
	float2 normPos;
	float2 texSize;
	float mixValue;
} fxVertexOut;

#define vec2 float2
#define vec3 float3
#define vec4 float4
#define mat4 float4x4
#define mat2 float2x2
#define mat3 float3x3
#define tex(a,b) float4(a.sample(linearSampler,b))
#define mod(x,y) ((x) - (y) * floor((x)/(y)))
#define discard discard_fragment()
#define fsTexture in.tex1

constexpr sampler linearSampler (mip_filter::nearest,mag_filter::linear,min_filter::linear,s_address::clamp_to_border,t_address::clamp_to_border,border_color::transparent_black);


#endif

