#version 330

uniform sampler2DRect inputTex;
uniform sampler2DRect inputTex1;
uniform float transitionProgress=1.0;
uniform float transitionAlpha=1.0;
uniform float baseAlpha=1.0;
uniform int transitionState;
uniform int direction=0;
uniform sampler2DRect maskTex;
in vec2 fsMaskTexture;


in vec2 fsTexture;
in vec2 fsTextureNormalized;
in float fsABSelect;
out vec4 outColor;

void main()
{
	vec4 texColor=texture(inputTex,fsTexture)*baseAlpha;
	vec4 colorA=mix(vec4(0,0,0,0),texColor,fsABSelect);
	vec4 colorB=mix(texColor,vec4(0,0,0,0),fsABSelect);

	float diffIn=0.0;
	float diffOut=1.0;

	//don't change this back to a switch.. Apple's MLSL compiler chokes and dies on it
	if(direction==0)
	{
		float tp=transitionProgress*1.1;
		
		diffIn=tp-(fsTextureNormalized.x+fsTextureNormalized.y)*.5;
		diffOut=(fsTextureNormalized.x+fsTextureNormalized.y)*.5-(tp-.1);
	}
	else if(direction==1)
	{
		float tp=(1.0-transitionProgress)*1.1;
		
		diffIn=fsTextureNormalized.y-(tp-.1);
		diffOut=tp-fsTextureNormalized.y;
	}
	else if(direction==2)
	{
		float tp=transitionProgress*1.1;
		diffIn=tp-(fsTextureNormalized.x+fsTextureNormalized.y)*.5;
		diffOut=(fsTextureNormalized.x+fsTextureNormalized.y)*.5-(tp-.1);
	}
	else if(direction==3)
	{
		float tp=transitionProgress*1.1;
		
		diffIn=tp-fsTextureNormalized.x;
		diffOut=fsTextureNormalized.x-(tp-.1);
	}
	else if(direction==4)
	{
		float tp=transitionProgress*1.1;
		
		diffIn=tp-fsTextureNormalized.x;
		diffOut=fsTextureNormalized.x-(tp-.1);
	}
	else if(direction==5)
	{
		float tp=(1.0-transitionProgress)*1.1;
		
		diffIn=fsTextureNormalized.x-(tp-.1);
		diffOut=tp-fsTextureNormalized.x;
	}
	else if(direction==6)
	{
		float tp=transitionProgress*1.1;
		
		diffIn=tp-(fsTextureNormalized.x+fsTextureNormalized.y)*.5;
		diffOut=(fsTextureNormalized.x+fsTextureNormalized.y)*.5-(tp-.1);
	}
	else if(direction==7)
	{
		float tp=transitionProgress*1.1;
		
		diffIn=tp-fsTextureNormalized.y;
		diffOut=fsTextureNormalized.y-(tp-.1);
	}
	else if(direction==8)
	{
		float tp=transitionProgress*1.1;
		diffIn=tp-(fsTextureNormalized.x+fsTextureNormalized.y)*.5;
		diffOut=(fsTextureNormalized.x+fsTextureNormalized.y)*.5-(tp-.1);
	}

	diffIn=clamp(diffIn*10.0,0.0,1.0);
	diffOut=clamp(diffOut*10.0,0.0,1.0);
	outColor=colorA*diffIn+colorB*diffOut;

#ifdef USE_MASK
	outColor.a*=texture(maskTex,fsMaskTexture).a;
#endif
}


